<?php
/**
 * Copyright © 2019 Filoblu S.p.A. All rights reserved.
 */

namespace FiloBlu\AdvancedCustomOptions\Setup;

use Magento\Framework\DB\Ddl\Table;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\UpgradeSchemaInterface;

/**
 * @codeCoverageIgnore
 */
class UpgradeSchema implements UpgradeSchemaInterface
{

    /**
     * Upgrades DB schema for a module
     *
     * @param SchemaSetupInterface $setup
     * @param ModuleContextInterface $context
     * @return void
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();

        if (version_compare($context->getVersion(), '1.0.1', '<=')) {
            $this->addCodeToCustomOptions($setup, $context);
        }

        $setup->endSetup();
    }

    /**
     * @param SchemaSetupInterface   $setup
     * @param ModuleContextInterface $context
     */
    public function addCodeToCustomOptions(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $orderTable = 'catalog_product_option';

        $setup->getConnection()
            ->addColumn(
                $setup->getTable($orderTable),
                'code',
                [
                    'type' => Table::TYPE_TEXT,
                    'length' => 255,
                    'comment' =>'Custom option code',
                    'after' => 'sku'
                ]
            );
    }
}
